package org.jeecg.modules.sensor.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.device.entity.BuDevice;
import org.jeecg.modules.device.service.IBuDeviceService;
import org.jeecg.modules.sensor.entity.BuSensor;
import org.jeecg.modules.sensor.entity.BuStatus;
import org.jeecg.modules.sensor.entity.Modbustcppar;
import org.jeecg.modules.sensor.entity.Mqttpar;
import org.jeecg.modules.sensor.service.IBuSensorService;
import org.jeecg.modules.sensor.service.IBuStatusService;
import org.jeecg.modules.sensor.service.IMqttparService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: mqttpar
 * @Author: jeecg-boot
 * @Date:   2024-10-15
 * @Version: V1.0
 */
@Api(tags="mqttpar")
@RestController
@RequestMapping("/sensor/mqttpar")
@Slf4j
public class MqttparController extends JeecgController<Mqttpar, IMqttparService> {
	@Autowired
	private IMqttparService mqttparService;
	 @Autowired
	 private IBuSensorService buSensorService;
	 @Autowired
	 private IBuDeviceService buDeviceService;
	 @Autowired
	 private IBuStatusService buStatusService;
	/**
	 * 分页列表查询
	 *
	 * @param mqttpar
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "mqttpar-分页列表查询")
	@ApiOperation(value="mqttpar-分页列表查询", notes="mqttpar-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<Mqttpar>> queryPageList(Mqttpar mqttpar,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<Mqttpar> queryWrapper = QueryGenerator.initQueryWrapper(mqttpar, req.getParameterMap());
		Page<Mqttpar> page = new Page<Mqttpar>(pageNo, pageSize);
		IPage<Mqttpar> pageList = mqttparService.page(page, queryWrapper);
		for (Mqttpar record : pageList.getRecords()) {
			BuSensor buSensor = buSensorService.getById(record.getSensorId());
			if(buSensor!=null){
				BuDevice buDevice = buDeviceService.getById(buSensor.getDeviceId());
				record.setDeviceName(buDevice.getDeviceName()+buDevice.getDeviceCode());
				record.setSensorName(buSensor.getName());
				BuStatus buStatus = buStatusService.getDataBySensorId(buSensor.getId());
				record.setSensorStatus(buStatus.getSensorStatus());
			}
		}
		if(mqttpar.getDeviceName()!=null){
			List<Mqttpar> collect = pageList.getRecords().stream().filter(e -> e.getDeviceName().contains(mqttpar.getDeviceName())).collect(Collectors.toList());
			pageList.setRecords(collect);
		}
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param mqttpar
	 * @return
	 */
	@AutoLog(value = "mqttpar-添加")
	@ApiOperation(value="mqttpar-添加", notes="mqttpar-添加")
	//@RequiresPermissions("org.jeecg.modules.demo:mqttpar:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody Mqttpar mqttpar) {
		mqttparService.save(mqttpar);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param mqttpar
	 * @return
	 */
	@AutoLog(value = "mqttpar-编辑")
	@ApiOperation(value="mqttpar-编辑", notes="mqttpar-编辑")
	//@RequiresPermissions("org.jeecg.modules.demo:mqttpar:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody Mqttpar mqttpar) {
		mqttparService.updateById(mqttpar);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "mqttpar-通过id删除")
	@ApiOperation(value="mqttpar-通过id删除", notes="mqttpar-通过id删除")
	//@RequiresPermissions("org.jeecg.modules.demo:mqttpar:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		mqttparService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "mqttpar-批量删除")
	@ApiOperation(value="mqttpar-批量删除", notes="mqttpar-批量删除")
	//@RequiresPermissions("org.jeecg.modules.demo:mqttpar:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.mqttparService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "mqttpar-通过id查询")
	@ApiOperation(value="mqttpar-通过id查询", notes="mqttpar-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<Mqttpar> queryById(@RequestParam(name="id",required=true) String id) {
		Mqttpar mqttpar = mqttparService.getById(id);
		if(mqttpar==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(mqttpar);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param mqttpar
    */
    //@RequiresPermissions("org.jeecg.modules.demo:mqttpar:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, Mqttpar mqttpar) {
        return super.exportXls(request, mqttpar, Mqttpar.class, "mqttpar");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("mqttpar:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, Mqttpar.class);
    }

}
